// 
// Prdio FEESC
//
// Por Rafael Silva e Souza - 9813239-3 
//
// Unidade  METRO

#include "colors.inc"
#include "skies.inc"
#include "glass.inc"

#declare CameraVisao  = 2; // Mude para alterar a cmera

#declare DUMMY        = 0.2;

#declare Frente       = 12;
#declare Profundidade = 15;
#declare Altura       = 17;

#declare AlturaAndar  = 3;
#declare Ledge        = 0.5;

#declare DistCameraX  = -20;
#declare DistCameraY  =  2;
#declare DistCameraZ  = -20;

#declare NroAndares   = 3;

#declare SecaoVidro   = Frente / 3;


// Inicializando

camera {
  #switch(CameraVisao)
    #case (0)
      location <DistCameraX, DistCameraY, DistCameraZ>
      look_at <Frente / 2, Altura / 2, Profundidade / 2>
    #break
    
    #case (1)
      location <Frente / 2, DistCameraY, DistCameraZ>
      look_at <Frente / 2, Altura / 2, Profundidade / 2>
    #break
    
    #case (2)
      location <-10, 0, Profundidade / 2>
      look_at <0.0, Altura, Profundidade / 2>
    #break
    
    #else
      location <(Frente / 2) - DistCameraX , DistCameraY, DistCameraZ>
      look_at <Frente / 2, Altura / 2, Profundidade / 2>
  #end
}


light_source { <-20000, 10000, -5000> color White }
light_source { <20000, 10000, -10000> color Gray70 shadowless }

sky_sphere {
    pigment {
        gradient y
        pigment_map {
            [0.01 rgb <0.847, 0.749, 0.847> ] // horizon
            [0.25 P_Cloud2 scale 0.25 rotate z*5]
            [0.60 P_Cloud3 scale <0.25, 0.15, 0.25> rotate z*10]
        }
    }
}

plane { y , 0 pigment { gradient z color_map { [ 0.0 DarkGreen ] [ 1.0 SeaGreen ] } } } // Cho


// Prdio

// Parede Esquerda

#declare Viga_Esq = (Profundidade / 2) + (SecaoVidro / 2);
#declare Viga_Dir = (Profundidade / 2) - (SecaoVidro / 2);

#declare ObjAndarTijolo = box { 
      < -1.0, (AlturaAndar + (AlturaAndar * 0.5) + Ledge), Ledge >, 
      < DUMMY + 1.0, (AlturaAndar + (AlturaAndar * 0.5)) + AlturaAndar + Ledge, Profundidade - Ledge >
};

#declare riscoMenor = box {
    < -Ledge , (AlturaAndar + (AlturaAndar * 0.5) + Ledge), Viga_Dir - (2* Ledge)  >
    < -(Ledge - 0.1), (AlturaAndar + (AlturaAndar * 0.5) + Ledge + 0.1), Profundidade - 3 >
    pigment { Gray40 }    
}

#declare aquelesRiscos = union {

  box {
    < -Ledge, (AlturaAndar + (AlturaAndar * 0.5) - 0.1), Viga_Dir - (2* Ledge)  >
    <  Ledge, (AlturaAndar + (AlturaAndar * 0.5)      ), Profundidade - 3 >
    pigment { Gray40 }    
  }

  box {
    < -Ledge, (AlturaAndar + (AlturaAndar * 0.5) + Ledge - 0.1), Viga_Dir - (2* Ledge)  >
    <  Ledge, (AlturaAndar + (AlturaAndar * 0.5) + Ledge      ), Profundidade - 3 >
    pigment { Gray40 }    
  }
  
  #declare Contador = 1;
  #while(Contador < 15 )
    object { riscoMenor translate y * Contador * (0.2) }
    #declare Contador = Contador + 1;
  #end     
  
  box {
    < -Ledge, (2 * AlturaAndar + (AlturaAndar * 0.5) + Ledge - 0.1), Viga_Dir - (2* Ledge)  >
    <  Ledge, (2 * AlturaAndar + (AlturaAndar * 0.5) + Ledge      ), Profundidade - 3 >
    pigment { Gray40 }    
  }  
  
}

union {

  difference {
    union {
    
      difference {
        box { 
          < 0, 0, 0 >, < DUMMY, Altura, Profundidade >
          pigment { Gray40 }
        }
      
        // Buracos pros andares de tijolo
        box { 
          < -1.0, Ledge, Ledge >, 
          < DUMMY + 1, (AlturaAndar + (AlturaAndar * 0.5)), Profundidade - Ledge >
        }
        
        #declare Contador = 0;
        #while(Contador < NroAndares)
          object { ObjAndarTijolo translate y * Contador * (AlturaAndar + Ledge) }
          #declare Contador = Contador + 1;
        #end   
      }
      
      // Tijolos
      box { 
        < 0.1, Ledge, Ledge >, < DUMMY, Altura, Profundidade >
        pigment { brick brick_size 0.2 mortar 0.1 }
      }
      
      // Duas vigas mais saltadas na vertical
      box {
        < -Ledge, 0.0, Viga_Esq >, < 0.0, Altura - 1, Viga_Esq + Ledge >  
        pigment { Gray40 }
      }
      
      box {
        < -Ledge, 0.0, Viga_Dir >, < 0.0, Altura - 1, Viga_Dir - Ledge >  
        pigment { Gray40 }
      }
      
      #declare Contador = 0;
        #while(Contador < NroAndares)
          object { aquelesRiscos translate y * Contador * (AlturaAndar + Ledge) }
          #declare Contador = Contador + 1;
      #end     
    }
    
    box {
      < -Ledge, Ledge, Viga_Dir>, < Ledge, (AlturaAndar + (AlturaAndar * 0.5)), Viga_Esq>
    }
    
  }
  
  box {
    < 0.0, Ledge, Viga_Dir>, < 0.2, (AlturaAndar + (AlturaAndar * 0.5)), Viga_Esq>
    color Col_Glass_General
      finish {
    specular 0.6
    roughness 0.002
    ambient 0
    diffuse 0.1
    reflection {
      0.05, 1.0
    }
    conserve_energy
    }
  } 
  
  // Parte de cima (a branca)
  
  polygon {
    10,
    < 0.0, Altura,                          0.0 >,
    < 0.0, Altura,                          Profundidade >,
    < 0.0, Altura + AlturaAndar,            Profundidade >,
    < 0.0, Altura + AlturaAndar,            Profundidade + Ledge >,
    < 0.0, Altura + AlturaAndar + 1.5,      Profundidade + Ledge >,
    < 0.0, Altura + AlturaAndar + 0.75,     Profundidade / 2 >,
    < 0.0, Altura + AlturaAndar + 1.5,      -Ledge >,
    < 0.0, Altura + AlturaAndar,            -Ledge >,
    < 0.0, Altura + AlturaAndar,            0.0 >,    
    < 0.0, Altura, 0.0 >
    pigment { color White }
  } 
  
  // Pra parede no cair...
  
  box {
    < 0.0, 0.0, 0.0 >, < Ledge, 20 * 0.8, Ledge >
    pigment { Gray30 }
    rotate < 0.0, 0.0, 45 >
    translate x * (Frente - Ledge - 0.08)    
    translate z * (Profundidade / 2)
    
  }  
  
  // VENTO SUL!!!!!!!!!!!!!!!!!!!!!!!
  // rotate < 0.0 0.0 90 >
}

